Index: palm/trunk/SOURCE/modules.f90
===================================================================
--- palm/trunk/SOURCE/modules.f90	(revision 2893)
+++ palm/trunk/SOURCE/modules.f90	(revision 2894)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! _prerun flags were removed, Control paramters restart_string and length have
+! been added
+! 
+! 2881 2018-03-13 16:24:40Z suehring
 ! Added flag for switching on/off calculation of soil moisture
 ! 
@@ -1077,4 +1081,5 @@
     CHARACTER (LEN=80)   ::  run_identifier                               !< run identifier as given by mrun option -d, ENVPAR namelist parameter provided by mrun
     CHARACTER (LEN=100)  ::  initializing_actions = ' '                   !< namelist parameter
+    CHARACTER (LEN=100)  ::  restart_string = ' '                         !< for storing strings in case of writing/reading restart data
     CHARACTER (LEN=210)  ::  run_description_header                       !< string containing diverse run informations as run identifier, coupling mode, host, ensemble number, run date and time
     CHARACTER (LEN=1000) ::  message_string = ' '                         !< dynamic string for error message output
@@ -1140,4 +1145,5 @@
     INTEGER(iwp) ::  io_blocks = 1                     !< number of blocks for which I/O is done in sequence (total number of PEs / maximum_parallel_io_streams)
     INTEGER(iwp) ::  iran = -1234567                   !< integer random number used for flow disturbances
+    INTEGER(iwp) ::  length = 0                        !< integer that specifies the length of a string in case of writing/reading restart data
     INTEGER(iwp) ::  masks = 0                         !< counter for number of masked output quantities
     INTEGER(iwp) ::  maximum_grid_level                !< number of grid levels that the multigrid solver is using
@@ -1301,5 +1307,4 @@
     LOGICAL ::  synchronous_exchange = .FALSE.                   !< namelist parameter
     LOGICAL ::  syn_turb_gen = .FALSE.                           !< flag for synthetic turbulence generator module
-    LOGICAL ::  syn_turb_gen_prerun = .FALSE.                    !< Was restart data of the sythentic turbulence generator written out? 
     LOGICAL ::  terminate_run = .FALSE.                          !< terminate run (cpu-time limit, restarts)?
     LOGICAL ::  topo_no_distinct = .FALSE.                       !< flag controlling classification of topography surfaces
@@ -1320,8 +1325,6 @@
     LOGICAL ::  uv_exposure = .FALSE.                            !< switch for uv exposure model
     LOGICAL ::  virtual_flight = .FALSE.                         !< use virtual flight model?
-    LOGICAL ::  virtual_flight_prerun = .FALSE.                  !< Was restart data of the virtual flight model written out?
     LOGICAL ::  wall_adjustment = .TRUE.                         !< namelist parameter
     LOGICAL ::  wind_turbine = .FALSE.                           !< flag for use of wind turbine model
-    LOGICAL ::  wind_turbine_prerun = .FALSE.                    !< Was restart data of the wtm model written out? 
     LOGICAL ::  write_binary = .FALSE.                           !< ENVPAR namelist parameter to steer restart I/O (ENVPAR is created by mrun)
     LOGICAL ::  ws_scheme_sca = .FALSE.                          !< use Wicker-Skamarock scheme (scalar advection)?
Index: palm/trunk/SOURCE/palm.f90
===================================================================
--- palm/trunk/SOURCE/palm.f90	(revision 2893)
+++ palm/trunk/SOURCE/palm.f90	(revision 2894)
@@ -25,4 +25,11 @@
 ! -----------------
 ! $Id$
+! Modified todo list, _write_restart_data/_last_actions has been renamed to 
+! _wrd_local, unit 14 will be opened now for each io_group
+! write_3d_binary is called wrd_local now, wrd_global moved from wrd_local to 
+! palm.f90, unit 14 is closed directly after the wrd_local call, Module related
+! routines for writing restart data have been moved to wrd_local
+! 
+! 2801 2018-02-14 16:01:55Z suehring
 ! Changed lpm from subroutine to module.
 ! Introduce particle transfer in nested models.
@@ -204,5 +211,4 @@
 !>
 !> @todo create routine last_actions instead of calling lsm_last_actions etc.
-!> @todo eventually move CALL usm_write_restart_data to suitable location
 !> @todo move chem_init call to init_3d_model or to check_parameters
 !------------------------------------------------------------------------------!
@@ -213,5 +219,5 @@
 
     USE chemistry_model_mod,                                                   &
-        ONLY:  chem_init, chem_last_actions
+        ONLY:  chem_init
 
     USE chem_photolysis_mod,                                                   &
@@ -222,8 +228,8 @@
                cloud_physics, constant_diffusion, coupling_char, coupling_mode,&
                do2d_at_begin, do3d_at_begin, humidity, initializing_actions,   &
-               io_blocks, io_group, land_surface, large_scale_forcing,         &
+               io_blocks, io_group, large_scale_forcing,                       &
                message_string, microphysics_morrison, microphysics_seifert,    &
                nest_domain, neutral, nudging, passive_scalar, runnr,           &
-               simulated_time, simulated_time_chr, spinup, urban_surface,      &
+               simulated_time, simulated_time_chr, spinup,                     &
                user_interface_current_revision,                                &
                user_interface_required_revision, version, wall_heatflux,       &
@@ -242,11 +248,11 @@
     USE kinds
 
-    USE land_surface_model_mod,                                                &
-        ONLY:  lsm_write_restart_data
-
     USE particle_attributes,                                                   &
         ONLY:  particle_advection
 
     USE pegrid
+
+    USE pmc_particle_interface,                                                &
+        ONLY: pmcp_g_alloc_win
 
     USE pmc_interface,                                                         &
@@ -255,12 +261,7 @@
                pmci_ensure_nest_mass_conservation
 
-    USE pmc_particle_interface,                                                 &
-        ONLY: pmcp_g_alloc_win
-
-    USE radiation_model_mod,                                                   &
-        ONLY:  radiation, radiation_last_actions
-       
-    USE urban_surface_mod,                                                     &
-        ONLY:  usm_write_restart_data        
+    USE write_restart_data_mod,                                                &
+        ONLY:  wrd_global, wrd_local
+
 
     IMPLICIT NONE
@@ -478,15 +479,24 @@
     IF ( write_binary )  THEN
 
-       CALL cpu_log( log_point(22), 'write_3d_binary', 'start' )
+       CALL cpu_log( log_point(22), 'wrd_local', 'start' )
 
        CALL location_message( 'writing restart data', .FALSE. )
-
-       CALL check_open( 14 )
 
        DO  i = 0, io_blocks-1
           IF ( i == io_group )  THEN
-!
-!--          Write flow field data
-             CALL write_3d_binary
+
+!
+!--          Open binary file 
+             CALL check_open( 14 )
+!
+!--          Write control parameters and other global variables for restart.
+             IF ( myid == 0 )  CALL wrd_global
+!
+!--          Write processor specific flow field data for restart runs
+             CALL wrd_local
+!
+!--          Close binary file 
+             CALL close_file( 14 )
+
           ENDIF
 #if defined( __parallel )
@@ -497,8 +507,8 @@
        CALL location_message( 'finished', .TRUE. )
 
-       CALL cpu_log( log_point(22), 'write_3d_binary', 'stop' )
-
-!
-!--    If required, write particle data
+       CALL cpu_log( log_point(22), 'wrd_local', 'stop' )
+
+!
+!--    If required, write particle data in own restart files
        IF ( particle_advection )  CALL lpm_write_restart_file
        
@@ -509,34 +519,14 @@
     IF ( myid == 0 )  CALL header
 !
-!-- If required, final land surface and user-defined actions, and
+!-- If required, final  user-defined actions, and
 !-- last actions on the open files and close files. Unit 14 was opened
-!-- in write_3d_binary but it is closed here, to allow writing on this
+!-- in wrd_local but it is closed here, to allow writing on this
 !-- unit in routine user_last_actions.
     CALL cpu_log( log_point(4), 'last actions', 'start' )
-    DO  i = 0, io_blocks-1
-       IF ( i == io_group )  THEN
-
-          IF ( urban_surface )  THEN
-             CALL usm_write_restart_data
-          ENDIF
-          IF ( land_surface )  THEN
-             CALL lsm_write_restart_data
-          ENDIF
-          IF ( radiation )  THEN
-             CALL radiation_last_actions
-          ENDIF
-          IF ( air_chemistry )  THEN
-             CALL chem_last_actions
-          ENDIF
           
-          CALL user_last_actions
-          IF ( write_binary )  CALL close_file( 14 )
-       ENDIF
-#if defined( __parallel )
-       CALL MPI_BARRIER( comm2d, ierr )
-#endif
-    ENDDO
+    CALL user_last_actions
     CALL close_file( 0 )
     CALL close_dvrp
+
     CALL cpu_log( log_point(4), 'last actions', 'stop' )
 
Index: palm/trunk/SOURCE/parin.f90
===================================================================
--- palm/trunk/SOURCE/parin.f90	(revision 2893)
+++ palm/trunk/SOURCE/parin.f90	(revision 2894)
@@ -25,4 +25,9 @@
 ! -----------------
 ! $Id$
+! read_var_list has been renamed to rrd_global, all module related _parin 
+! routines are called before reading the global restart data to overwrite them
+! in case of restart runs
+! 
+! 2881 2018-03-13 16:24:40Z suehring
 ! Added flag for switching on/off calculation of soil moisture
 ! 
@@ -408,5 +413,8 @@
 
     USE radiation_model_mod,                                                   &
-        ONLY: radiation_parin  
+        ONLY: radiation_parin
+
+    USE read_restart_data_mod,                                                 &
+        ONLY:  rrd_global     
 
     USE spectra_mod,                                                           &
@@ -614,10 +622,79 @@
 
 !
+!--       Try to read runtime parameters given by the user for this run
+!--       (namelist "d3par"). The namelist "d3par" can be omitted. In that case
+!--       default values are used for the parameters.
+ 12       line = ' '
+
+          REWIND ( 11 )
+          line = ' '
+          DO   WHILE ( INDEX( line, '&d3par' ) == 0 )
+             READ ( 11, '(A)', END=20 )  line
+          ENDDO
+          BACKSPACE ( 11 )
+
+!
+!--       Read namelist
+          READ ( 11, d3par )
+
+ 20       CONTINUE
+
+!
+!--       Check if land surface model is used and read &lsm_par if required
+          CALL lsm_parin
+
+!
+!--       Check if urban surface model is used and read &urban_surface_par if required
+          CALL usm_parin
+
+!
+!--       Check if spectra shall be calculated and read spectra_par if required
+          CALL spectra_parin
+
+!
+!--       Check if radiation model is used and read &radiation_par if required
+          CALL radiation_parin
+
+!
+!--       Check if gust module is used and read &gust_par if required
+          CALL gust_parin
+ 
+ 
+!--       Check if plant canopy model is used and read &canopy_par if required
+          CALL pcm_parin
+ 
+!
+!--       Read control parameters for optionally used model software packages
+          CALL package_parin
+
+!
+!--       Check if wind turbine model is used and read &wind_turbine_par if
+!--       required
+          CALL wtm_parin
+!
+!--       Check if virtual flights should be carried out and read &flight_par
+!--       if required
+          CALL flight_parin
+!
+!--       Check if synthetic turbulence generator is used and read stg_par if
+!--       required
+          CALL stg_parin
+!
+!--       Read chemistry variables
+          CALL chem_parin
+!
+!--       Check if uv exposure model is used and read &uvexposure_par
+          CALL uvem_parin
+!
+!--       Read user-defined variables
+          CALL user_parin
+
+!
 !--       If required, read control parameters from restart file (produced by
 !--       a prior run). All PEs are reading from file created by PE0 (see
 !--       check_open)
- 12       IF ( TRIM( initializing_actions ) == 'read_restart_data' )  THEN
-             CALL read_var_list
-
+          IF ( TRIM( initializing_actions ) == 'read_restart_data' )  THEN
+
+             CALL rrd_global
 !
 !--          Increment the run count
@@ -724,83 +801,8 @@
 
 !
-!--       Try to read runtime parameters given by the user for this run
-!--       (namelist "d3par"). The namelist "d3par" can be omitted. In that case
-!--       default values are used for the parameters.
-          line = ' '
-
-          REWIND ( 11 )
-          line = ' '
-          DO   WHILE ( INDEX( line, '&d3par' ) == 0 )
-             READ ( 11, '(A)', END=20 )  line
-          ENDDO
-          BACKSPACE ( 11 )
-
-!
-!--       Read namelist
-          READ ( 11, d3par )
-
- 20       CONTINUE
-
-!
-!--       Check if land surface model is used and read &lsm_par if required
-          CALL lsm_parin
-
-!
-!--       Check if urban surface model is used and read &urban_surface_par if required
-          CALL usm_parin
-
-!
-!--       Check if spectra shall be calculated and read spectra_par if required
-          CALL spectra_parin
-
-!
-!--       Check if radiation model is used and read &radiation_par if required
-          CALL radiation_parin
-
-!
-!--       Check if gust module is used and read &gust_par if required
-          CALL gust_parin
- 
- 
-!--       Check if plant canopy model is used and read &canopy_par if required
-          CALL pcm_parin
- 
-!
-!--       Read control parameters for optionally used model software packages
-          CALL package_parin
-
-!
-!--       Check if wind turbine model is used and read &wind_turbine_par if
-!--       required
-          CALL wtm_parin
-!
-!--       Check if virtual flights should be carried out and read &flight_par
-!--       if required
-          CALL flight_parin
-!
-!--       Check if synthetic turbulence generator is used and read stg_par if
-!--       required
-          CALL stg_parin
-!
-!--       Read chemistry variables
-          CALL chem_parin
-!
-!--       Check if uv exposure model is used and read &uvexposure_par
-          CALL uvem_parin
-!
-!--       Read user-defined variables
-          CALL user_parin
-
-!
-!--       The restart file will be reopened when reading the subdomain data
-          IF ( TRIM( initializing_actions ) == 'read_restart_data' )  THEN
-             CALL close_file( 13 )
-          ENDIF
-
-!
 !--       Check in case of initial run, if the grid point numbers are well
 !--       defined and allocate some arrays which are already needed in
 !--       init_pegrid or check_parameters. During restart jobs, these arrays
-!--       will be allocated in read_var_list. All other arrays are allocated
+!--       will be allocated in rrd_global. All other arrays are allocated
 !--       in init_3d_model.
           IF ( TRIM( initializing_actions ) /= 'read_restart_data' )  THEN
@@ -823,5 +825,5 @@
 !
 !--          ATTENTION: in case of changes to the following statement please
-!--                  also check the allocate statement in routine read_var_list
+!--                  also check the allocate statement in routine rrd_global
              ALLOCATE( pt_init(0:nz+1), q_init(0:nz+1), s_init(0:nz+1),        &
                        ref_state(0:nz+1), sa_init(0:nz+1), ug(0:nz+1),         &
Index: palm/trunk/SOURCE/radiation_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/radiation_model_mod.f90	(revision 2893)
+++ palm/trunk/SOURCE/radiation_model_mod.f90	(revision 2894)
@@ -25,4 +25,16 @@
 ! -----------------
 ! $Id$
+! Calculations of the index range of the subdomain on file which overlaps with
+! the current subdomain are already done in read_restart_data_mod
+! radiation_read_restart_data was renamed to radiation_rrd_local and 
+! radiation_last_actions was renamed to radiation_wrd_local, variable named 
+! found has been introduced for checking if restart data was found, reading 
+! of restart strings has been moved completely to read_restart_data_mod, 
+! radiation_rrd_local is already inside the overlap loop programmed in 
+! read_restart_data_mod, the marker *** end rad *** is not necessary anymore,
+! strings and their respective lengths are written out and read now in case of 
+! restart runs to get rid of prescribed character lengths (Giersch)
+!
+! 2809 2018-02-15 09:55:58Z suehring
 ! Bugfix for gfortran: Replace the function C_SIZEOF with STORAGE_SIZE
 ! 
@@ -809,11 +821,11 @@
     END INTERFACE radiation_tendency
 
-    INTERFACE radiation_read_restart_data
-       MODULE PROCEDURE radiation_read_restart_data
-    END INTERFACE radiation_read_restart_data
-
-    INTERFACE radiation_last_actions
-       MODULE PROCEDURE radiation_last_actions
-    END INTERFACE radiation_last_actions
+    INTERFACE radiation_rrd_local
+       MODULE PROCEDURE radiation_rrd_local
+    END INTERFACE radiation_rrd_local
+
+    INTERFACE radiation_wrd_local
+       MODULE PROCEDURE radiation_wrd_local
+    END INTERFACE radiation_wrd_local
 
     INTERFACE radiation_interaction
@@ -853,6 +865,6 @@
            radiation_3d_data_averaging, radiation_tendency,                    &
            radiation_data_output_2d, radiation_data_output_3d,                 &
-           radiation_define_netcdf_grid, radiation_last_actions,               &
-           radiation_read_restart_data, radiation_data_output_mask,            &
+           radiation_define_netcdf_grid, radiation_wrd_local,                  &
+           radiation_rrd_local, radiation_data_output_mask,                    &
            radiation_radflux_gridbox, radiation_calc_svf, radiation_write_svf, &
            radiation_interaction, radiation_interaction_init,                  &
@@ -8030,79 +8042,104 @@
 ! Description:
 ! ------------
-!> Subroutine defines masked output variables
+!> Subroutine writes the respective restart data
 !------------------------------------------------------------------------------!
- SUBROUTINE radiation_last_actions
- 
-
-    USE control_parameters
-        
-    USE kinds
+ SUBROUTINE radiation_wrd_local
+
 
     IMPLICIT NONE
 
-    IF ( write_binary )  THEN
-       IF ( ALLOCATED( rad_net_av ) )  THEN
-          WRITE ( 14 )  'rad_net_av          ';  WRITE ( 14 )  rad_net_av  
-       ENDIF  
-       IF ( ALLOCATED( rad_lw_in ) )  THEN
-          WRITE ( 14 )  'rad_lw_in           ';  WRITE ( 14 )  rad_lw_in  
-       ENDIF
-       IF ( ALLOCATED( rad_lw_in_av ) )  THEN
-          WRITE ( 14 )  'rad_lw_in_av        ';  WRITE ( 14 )  rad_lw_in_av  
-       ENDIF 
-       IF ( ALLOCATED( rad_lw_out ) )  THEN
-          WRITE ( 14 )  'rad_lw_out          ';  WRITE ( 14 )  rad_lw_out 
-       ENDIF 
-       IF ( ALLOCATED( rad_lw_out_av ) )  THEN
-          WRITE ( 14 )  'rad_lw_out_av       ';  WRITE ( 14 )  rad_lw_out_av  
-       ENDIF 
-       IF ( ALLOCATED( rad_lw_cs_hr ) )  THEN
-          WRITE ( 14 )  'rad_lw_cs_hr        ';  WRITE ( 14 )  rad_lw_cs_hr
-       ENDIF
-       IF ( ALLOCATED( rad_lw_cs_hr_av ) )  THEN
-          WRITE ( 14 )  'rad_lw_cs_hr_av     ';  WRITE ( 14 )  rad_lw_cs_hr_av
-       ENDIF
-       IF ( ALLOCATED( rad_lw_hr ) )  THEN
-          WRITE ( 14 )  'rad_lw_hr           ';  WRITE ( 14 )  rad_lw_hr
-       ENDIF
-       IF ( ALLOCATED( rad_lw_hr_av ) )  THEN
-          WRITE ( 14 )  'rad_lw_hr_av        ';  WRITE ( 14 )  rad_lw_hr_av
-       ENDIF
-       IF ( ALLOCATED( rad_sw_in ) )  THEN
-          WRITE ( 14 )  'rad_sw_in           ';  WRITE ( 14 )  rad_sw_in  
-       ENDIF 
-       IF ( ALLOCATED( rad_sw_in_av ) )  THEN
-          WRITE ( 14 )  'rad_sw_in_av        ';  WRITE ( 14 )  rad_sw_in_av  
-       ENDIF 
-       IF ( ALLOCATED( rad_sw_out ) )  THEN
-          WRITE ( 14 )  'rad_sw_out          ';  WRITE ( 14 )  rad_sw_out  
-       ENDIF 
-       IF ( ALLOCATED( rad_sw_out_av ) )  THEN
-          WRITE ( 14 )  'rad_sw_out_av       ';  WRITE ( 14 )  rad_sw_out_av  
-       ENDIF 
-       IF ( ALLOCATED( rad_sw_cs_hr ) )  THEN
-          WRITE ( 14 )  'rad_sw_cs_hr        ';  WRITE ( 14 )  rad_sw_cs_hr
-       ENDIF
-       IF ( ALLOCATED( rad_sw_cs_hr_av ) )  THEN
-          WRITE ( 14 )  'rad_sw_cs_hr_av     ';  WRITE ( 14 )  rad_sw_cs_hr_av
-       ENDIF
-       IF ( ALLOCATED( rad_sw_hr ) )  THEN
-          WRITE ( 14 )  'rad_sw_hr           ';  WRITE ( 14 )  rad_sw_hr
-       ENDIF
-       IF ( ALLOCATED( rad_sw_hr_av ) )  THEN
-          WRITE ( 14 )  'rad_sw_hr_av        ';  WRITE ( 14 )  rad_sw_hr_av
-       ENDIF
-
-       WRITE ( 14 )  '*** end rad ***     '
-
+
+    IF ( ALLOCATED( rad_net_av ) )  THEN
+       CALL wrd_write_string( 'rad_net_av' )
+       WRITE ( 14 )  rad_net_av
     ENDIF
 
- END SUBROUTINE radiation_last_actions
-
-
-SUBROUTINE radiation_read_restart_data( i, nxlfa, nxl_on_file, nxrfa,          &
-                                        nxr_on_file, nynfa, nyn_on_file, nysfa,&
-                                        nys_on_file, offset_xa, offset_ya,     &
-                                        overlap_count, tmp_2d, tmp_3d )
+    IF ( ALLOCATED( rad_lw_in ) )  THEN
+       CALL wrd_write_string( 'rad_lw_in' )
+       WRITE ( 14 )  rad_lw_in
+    ENDIF
+
+    IF ( ALLOCATED( rad_lw_in_av ) )  THEN
+       CALL wrd_write_string( 'rad_lw_in_av' )
+       WRITE ( 14 )  rad_lw_in_av
+    ENDIF
+
+    IF ( ALLOCATED( rad_lw_out ) )  THEN
+       CALL wrd_write_string( 'rad_lw_out' )
+       WRITE ( 14 )  rad_lw_out
+    ENDIF
+
+    IF ( ALLOCATED( rad_lw_out_av) )  THEN
+       CALL wrd_write_string( 'rad_lw_out_av' )
+       WRITE ( 14 )  rad_lw_out_av
+    ENDIF
+
+    IF ( ALLOCATED( rad_lw_cs_hr) )  THEN
+       CALL wrd_write_string( 'rad_lw_cs_hr' )
+       WRITE ( 14 )  rad_lw_cs_hr
+    ENDIF
+
+    IF ( ALLOCATED( rad_lw_cs_hr_av) )  THEN
+       CALL wrd_write_string( 'rad_lw_cs_hr_av' )
+       WRITE ( 14 )  rad_lw_cs_hr_av
+    ENDIF
+
+    IF ( ALLOCATED( rad_lw_hr) )  THEN
+       CALL wrd_write_string( 'rad_lw_hr' )
+       WRITE ( 14 )  rad_lw_hr
+    ENDIF
+
+    IF ( ALLOCATED( rad_lw_hr_av) )  THEN
+       CALL wrd_write_string( 'rad_lw_hr_av' )
+       WRITE ( 14 )  rad_lw_hr_av
+    ENDIF
+
+    IF ( ALLOCATED( rad_sw_in) )  THEN
+       CALL wrd_write_string( 'rad_sw_in' )
+       WRITE ( 14 )  rad_sw_in
+    ENDIF
+
+    IF ( ALLOCATED( rad_sw_in_av) )  THEN
+       CALL wrd_write_string( 'rad_sw_in_av' )
+       WRITE ( 14 )  rad_sw_in_av
+    ENDIF
+
+    IF ( ALLOCATED( rad_sw_out) )  THEN
+       CALL wrd_write_string( 'rad_sw_out' )
+       WRITE ( 14 )  rad_sw_out
+    ENDIF
+
+    IF ( ALLOCATED( rad_sw_out_av) )  THEN
+       CALL wrd_write_string( 'rad_sw_out_av' )
+       WRITE ( 14 )  rad_sw_out_av
+    ENDIF
+
+    IF ( ALLOCATED( rad_sw_cs_hr) )  THEN
+       CALL wrd_write_string( 'rad_sw_cs_hr' )
+       WRITE ( 14 )  rad_sw_cs_hr
+    ENDIF
+
+    IF ( ALLOCATED( rad_sw_cs_hr_av) )  THEN
+       CALL wrd_write_string( 'rad_sw_cs_hr_av' )
+       WRITE ( 14 )  rad_sw_cs_hr_av
+    ENDIF
+
+    IF ( ALLOCATED( rad_sw_hr) )  THEN
+       CALL wrd_write_string( 'rad_sw_hr' )
+       WRITE ( 14 )  rad_sw_hr
+    ENDIF
+
+    IF ( ALLOCATED( rad_sw_hr_av) )  THEN
+       CALL wrd_write_string( 'rad_sw_hr_av' )
+       WRITE ( 14 )  rad_sw_hr_av
+    ENDIF
+
+
+ END SUBROUTINE radiation_wrd_local
+
+
+SUBROUTINE radiation_rrd_local( i, k, nxlf, nxlc, nxl_on_file, nxrf, nxrc,     &
+                                nxr_on_file, nynf, nync, nyn_on_file, nysf,    &
+                                nysc, nys_on_file, tmp_2d, tmp_3d, found )
  
 
@@ -8115,7 +8152,6 @@
     USE pegrid
 
+
     IMPLICIT NONE
-
-    CHARACTER (LEN=20) :: field_char   !< 
 
     INTEGER(iwp) ::  i               !< 
